
/* clock.c
 * ВК-6 v0.31
 * (c) Васильев И.В., Москва, 7 марта 2010 г.
 *
 * Программа распространяется под лицензией GNU GPL v3.
 *
 * Функции реального времени: часы реального времени, таймеры и звук.
 *
 * Функциональный узел ЭКВМ: часы реального времени.
 * Функциональный узел ЭКВМ: устройство звуковой сигнализации (динамик).
 */

#include <time.h>
#include <stdio.h>

#include "cpu.h"
#include "clock.h"
#include "supp.h"
#include "os.h"


unsigned char iDate = 7, iMonth = 3, iDay = 7;
unsigned char iHour = 12, iMinute = 30, iSecond = 30;
int iYear = 2010;

long lTimer0 = 0, lTimer1 = 0;
static long lSound = 0, lFreq = 0;
static long lKeyFreq = 0, lKeyDur = 0;
static long clkTimer0, clkTimer1, clkSound;


void KbdClick(void)
/* Клик клавиатуры. */
{
}


void TimerAdjust(void)
/* Очередная проверка таймеров. */
{ long clkNow = OsTime();
  if (lTimer0)
  { if (clkNow>=clkTimer0) lTimer0 = 0;
    else lTimer0 = clkTimer0-clkNow;
  }
  if (lTimer1)
  { if (clkNow>=clkTimer1) lTimer1 = 0;
    else lTimer1 = clkTimer1-clkNow;
  }
  if (lSound)
  { if (clkNow>=clkSound) lSound = 0;
    else lSound = clkSound-clkNow;
  }
}


void R9050w(void)
{ lTimer0 = Trunc(65535);
  if (lTimer0) clkTimer0 = OsTime() + lTimer0;
}


void R9051w(void)
{ lTimer1 = Trunc(65535);
  if (lTimer1) clkTimer1 = OsTime() + lTimer1;
}


void R9052w(void)
{ lSound = Trunc(65535);
  lFreq = TruncY(25000);
  if (lSound) clkSound = OsTime() + lSound;
}


void R9052r(void)
{ Push(lFreq);
  Push(lSound);
}


void R9053w(void)
{ lKeyDur = Trunc(65535);
  lKeyFreq = TruncY(25000);
}


void R9053r(void)
{ Push(lKeyFreq);
  Push(lKeyDur);
}


void ClockInit(void)
/* Установить дату ВК-6 по дате операционной системы. */
{ time_t t0 = time(NULL);
  if (t0!=-1)
  { struct tm *t = localtime(&t0);
    iDate = t->tm_mday;
    iMonth = t->tm_mon + 1;
    iYear = t->tm_year + 1900;
    iDay = t->tm_wday;
    if (iDay==0) iDay = 7;
  }
  lTimer0 = lTimer1 = lSound = lFreq = 0;
  lKeyDur = lKeyFreq = 0;
}

void R9055r(void)
{ time_t t1 = time(NULL);
  if (t1!=-1)
  { struct tm *t = localtime(&t1);
    iHour = t->tm_hour;
    iMinute = t->tm_min;
    iSecond = t->tm_sec;
    if (iSecond>=60) iSecond -= 60,  iMinute++;
    if (iMinute>=60) iMinute -= 60,  iHour++;
    if (iHour>=24) iHour -= 24;
  }
  Push(iHour+iMinute/100.L+iSecond/10000.L);
}


