
/* comment.c
 * ВК-6 v0.31
 * (c) Васильев И.В., Москва, 6 марта 2010 г.
 *
 * Программа распространяется под лицензией GNU GPL v3.
 *
 * Поддержка строки комментариев в ВК-6.
 */

#include "cpu.h"
#include "decomp.h"
#include "comment.h"
#include "reg.h"
#include "supp.h"


unsigned char strComment[COMMENT_LINE_MAXLEN];
int iCommentLen=0;


void CommentStoreCh(unsigned char c)
{ if ((c==10) || (c==13)) iCommentLen = 0;
  else if (iCommentLen<COMMENT_LINE_MAXLEN)
    strComment[iCommentLen++] = c;
}


void CommentAddLine(const char *s)
{ while (*s && (iCommentLen<COMMENT_LINE_MAXLEN))
    CommentStoreCh((unsigned char)*s++);
}


void CommentLine(const char *s)
{ CommentStoreCh(13); 
  CommentAddLine(s);
}


void State(const unsigned char *s)
{ if (iMode!=1) CommentLine((const char *) s);
}


void State1(int c)
{ if (iMode!=1) CommentLine((const char *) Mnemo1(c));
}


void R9025w(void)
{ CommentStoreCh(MkByte(RX));
}


void R9026w(void)
{ int i=Trunc(9999);
  unsigned char c;
  while ( (iCommentLen<COMMENT_LINE_MAXLEN) &&
          (i<=9999) && (c=bProg[i++]) && (c!=255) ) CommentStoreCh(c);
}


void R9027w(void)
{ int i=Trunc(8167)-1000;
  if (i>=0)
  { unsigned char c;
    while ( (iCommentLen<COMMENT_LINE_MAXLEN) &&
            (i<7168) && (c=bR[i++]) && (c!=255) ) CommentStoreCh(c);
  }
}

